#CFA abd EFA

model <- 'satisf =~ sat1 + sat2 + sat3 + sat4 + sat5 + sat6
difficulty =~ diff1 + diff2 + diff3 + diff4 + diff5
accuracy =~ acc1 + acc2 + acc3 + acc4 + acc5
diversity =~ div1 + div2 + div3 + div4 + div5'
fit <- cfa(model, data=movie, ordered = names(movie), std.lv = TRUE)
summary(fit, rsquare = TRUE, fit.measures = TRUE)

model1 <- 'satisf =~ sat1 + sat2 + sat3 + sat4 + sat5
difficulty =~ diff1 + diff2 + diff3 + diff4 + diff5
accuracy =~ acc1 + acc2 + acc3 + acc4 + acc5
diversity =~ div1 + div2 + div3 + div4 + div5'
fit <- cfa(model1, data=movie, ordered = names(movie), std.lv = TRUE)
summary(fit, rsquare = TRUE, fit.measures = TRUE)

mods <- modindices(fit, power = TRUE)
mods
mods <- mods[grep("\\*", mods$decision),]
mods

model2 <- 'satisf =~ sat1 + sat2 + sat3 + sat4 + sat5
difficulty =~ diff2 + diff3 + diff4 + diff5
accuracy =~ acc1 + acc2 + acc3 + acc4 + acc5
diversity =~ div1 + div2 + div3 + div4 + div5'
fit <- cfa(model2, data=movie, ordered = names(movie), std.lv = TRUE)
summary(fit, rsquare = TRUE, fit.measures = TRUE)

mods <- modindices(fit, power = TRUE)
mods
mods <- mods[grep("\\*", mods$decision),]
mods

model3 <- 'satisf =~ sat1 + sat2 + sat3 + sat4 + sat5
difficulty =~ diff3 + diff4 + diff5
accuracy =~ acc1 + acc2 + acc3 + acc4 + acc5
diversity =~ div1 + div2 + div3 + div4 + div5'
fit <- cfa(model3, data=movie, ordered = names(movie), std.lv = TRUE)
summary(fit, rsquare = TRUE, fit.measures = TRUE)

mods <- modindices(fit, power = TRUE)
mods
mods <- mods[grep("\\*", mods$decision),]
mods

model4 <- 'satisf =~ sat1 + sat2 + sat3 + sat4 + sat5
difficulty =~ diff4 + diff5
accuracy =~ acc1 + acc2 + acc3 + acc4 + acc5
diversity =~ div1 + div2 + div3 + div4 + div5'
fit <- cfa(model4, data=movie, ordered = names(movie), std.lv = TRUE)
summary(fit, rsquare = TRUE, fit.measures = TRUE)

mods <- modindices(fit, power = TRUE)
mods
mods <- mods[grep("\\*", mods$decision),]
mods

scree(privbeh)
f3 <- fa(privbeh, nfactors = 3, fm = "wls", rotate = "geominQ")
f3

f4 <- fa(privbeh, nfactors = 4, fm = "wls", rotate = "geominQ")
f4

#improved factor model by removing items with lowest communality
f4_1 <- fa(privbeh[, -c(2,11,12)], nfactors = 4, fm = "wls", rotate = "geominQ")
f4_1



f5 <- fa(privbeh, nfactors = 5, fm = "wls", rotate = "geominQ")
f5

f5_1 <- fa(privbeh[, -c(2,8,12)], nfactors = 5, fm = "wls", rotate = "geominQ")
f5_1



1-pchisq(f3$STATISTIC - f4$STATISTIC, f3$dof - f4$dof)
f3$dof - f4$dof

1-pchisq(f4_1$STATISTIC - f5_1$STATISTIC, f4_1$dof - f5_1$dof)
f4_1$dof - f5_1$dof
